diff --git a/src/main/java/net/minecraft/client/gui/achievements/GuiAchievements.java b/src/main/java/net/minecraft/client/gui/achievements/AchievementsScreen.java
similarity index 91%
rename from src/main/java/net/minecraft/client/gui/achievements/GuiAchievements.java
rename to src/main/java/net/minecraft/client/gui/achievements/AchievementsScreen.java
index 4ddc835e7..e0f690869 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/GuiAchievements.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/AchievementsScreen.java
@@ -1,14 +1,14 @@
 package net.minecraft.client.gui.achievements;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiRenderItem;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.GuiTooltip;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.ItemElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.achievements.data.AchievementPage;
 import net.minecraft.client.gui.achievements.data.AchievementPageRegistry;
 import net.minecraft.client.gui.achievements.data.AchievementPages;
-import net.minecraft.client.gui.options.GuiOptionsButton;
+import net.minecraft.client.gui.options.OptionsButtonElement;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
@@ -37,7 +37,7 @@ import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
 import static org.lwjgl.opengl.GL11.glDisable;
 import static org.lwjgl.opengl.GL11.glEnable;
 
-public class GuiAchievements extends GuiScreen
+public class AchievementsScreen extends Screen
 {
 
 
@@ -67,9 +67,9 @@ public class GuiAchievements extends GuiScreen
     protected double currentShiftY;
     private boolean draggingViewport;
     private final StatsCounter statsCounter;
-    private final GuiTooltip tooltip;
-    private GuiRenderItem renderItem = null;
-    GuiScreen parent;
+    private final TooltipElement tooltip;
+    private ItemElement renderItem = null;
+    Screen parent;
 
     private int top;
     private int bottom;
@@ -104,7 +104,7 @@ public class GuiAchievements extends GuiScreen
 
     private @NotNull BGLayer[] layers;
 
-    public GuiAchievements(GuiScreen parent, StatsCounter statsCounter)
+    public AchievementsScreen(Screen parent, StatsCounter statsCounter)
     {
         mouseXOld = 0;
         mouseYOld = 0;
@@ -113,8 +113,8 @@ public class GuiAchievements extends GuiScreen
 
         this.parent = parent;
         this.mc = Minecraft.getMinecraft(this);
-        this.tooltip = new GuiTooltip(mc);
-        this.renderItem = new GuiRenderItem(mc);
+        this.tooltip = new TooltipElement(mc);
+        this.renderItem = new ItemElement(mc);
 
         layers = new BGLayer[currentPage.backgroundLayers()];
         for (int i = 0; i < layers.length; i++) {
@@ -125,8 +125,8 @@ public class GuiAchievements extends GuiScreen
     @Override
 	public void init()
     {
-        controlList.clear();
-        controlList.add(new GuiOptionsButton(1, width / 2 - 100, height - 20 - BUTTON_SPACING, 200, 20, I18n.getInstance().translateKey("gui.achievements.button.done")));
+        buttons.clear();
+        buttons.add(new OptionsButtonElement(1, width / 2 - 100, height - 20 - BUTTON_SPACING, 200, 20, I18n.getInstance().translateKey("gui.achievements.button.done")));
 
         lastTileX = Integer.MIN_VALUE;
         lastTileY = Integer.MIN_VALUE;
@@ -185,33 +185,33 @@ public class GuiAchievements extends GuiScreen
     }
 
     @Override
-	protected void buttonPressed(GuiButton button) {
+	protected void buttonClicked(ButtonElement button) {
         if(button.id == 1) {
-            mc.displayGuiScreen(parent);
+            mc.displayScreen(parent);
             //mc.setIngameFocus();
         }
-        super.buttonPressed(button);
+        super.buttonClicked(button);
     }
 
     @Override
-	public void keyTyped(char c, int key, int mouseX, int mouseY)
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
-        if (key == Keyboard.KEY_ESCAPE) {
-            mc.displayGuiScreen(parent);
+        if (eventKey == Keyboard.KEY_ESCAPE) {
+            mc.displayScreen(parent);
         } else {
-            super.keyTyped(c, key, mouseX, mouseY);
+            super.keyPressed(eventCharacter, eventKey, mx, my);
         }
     }
     @Override
-    public void mouseClicked(int mouseX, int mouseY, int mouseButton) {
-        if (drawSidebar() && mouseX >= pageListLeft && mouseX <= (pageListRight - 6) && mouseY >= top && mouseY <= bottom) {
+    public void mouseClicked(int mx, int my, int buttonNum) {
+        if (drawSidebar() && mx >= pageListLeft && mx <= (pageListRight - 6) && my >= top && my <= bottom) {
             int pagesListHeight = getTotalPagesListHeight();
             int pagesListY = top - (int) pageListScrollAmount;
             if (pagesListHeight < bottom - top) {
                 pagesListY = top + (bottom - top - pagesListHeight) / 2;
             }
             for(AchievementPage page : AchievementPageRegistry.getInstance().getPages()) {
-                if (mouseX >= pageListLeft && mouseX <= (pageListRight - 6) && mouseY >= pagesListY && mouseY <= pagesListY + PAGE_BUTTON_HEIGHT) {
+                if (mx >= pageListLeft && mx <= (pageListRight - 6) && my >= pagesListY && my <= pagesListY + PAGE_BUTTON_HEIGHT) {
                     currentPage = page;
                     mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
 
@@ -226,27 +226,27 @@ public class GuiAchievements extends GuiScreen
                 pagesListY += PAGE_BUTTON_HEIGHT;
             }
         }
-        super.mouseClicked(mouseX, mouseY, mouseButton);
+        super.mouseClicked(mx, my, buttonNum);
 
-        clickX = mouseX;
-        clickY = mouseY;
+        clickX = mx;
+        clickY = my;
     }
 
     @Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick)
+	public void render(int xm, int ym, float partialTick)
     {
         if(Mouse.isButtonDown(0)) {
-            if(mouseX >= viewportLeft && mouseX < viewportRight && mouseY >= viewportTop && mouseY < viewportBottom) {
+            if(xm >= viewportLeft && xm < viewportRight && ym >= viewportTop && ym < viewportBottom) {
                 if(!draggingViewport) {
                     draggingViewport = true;
                 } else {
-                    targetShiftX -= (mouseX - mouseXOld) / viewportZoom;
-                    targetShiftY -= (mouseY - mouseYOld) / viewportZoom;
+                    targetShiftX -= (xm - mouseXOld) / viewportZoom;
+                    targetShiftY -= (ym - mouseYOld) / viewportZoom;
                     currentShiftX = oldShiftX = targetShiftX;
                     currentShiftY = oldShiftY = targetShiftY;
                 }
-                mouseXOld = mouseX;
-                mouseYOld = mouseY;
+                mouseXOld = xm;
+                mouseYOld = ym;
             }
             currentShiftX =  MathHelper.clamp(currentShiftX, shiftMinX, shiftMaxX);
             currentShiftY =  MathHelper.clamp(currentShiftY, shiftMinY, shiftMaxY);
@@ -257,14 +257,14 @@ public class GuiAchievements extends GuiScreen
             draggingViewport = false;
         }
 
-        if (drawSidebar() &&mouseX >= pageListLeft && mouseX <= pageListRight) {
+        if (drawSidebar() && xm >= pageListLeft && xm <= pageListRight) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 scrollPagesList(Mouse.getDWheel() / -0.01f);
             } else {
                 scrollPagesList(Mouse.getDWheel() / -0.05f);
             }
             onScrollPagesList();
-        } else if (mouseX >= viewportLeft && mouseX <= viewportRight && mouseY >= viewportTop && mouseY <= viewportBottom){
+        } else if (xm >= viewportLeft && xm <= viewportRight && ym >= viewportTop && ym <= viewportBottom){
             viewportZoom = MathHelper.clamp(viewportZoom + (Mouse.getDWheel()/10d), 0.5d, 2);
 
             // Make zoom notch onto integer multiples
@@ -278,13 +278,13 @@ public class GuiAchievements extends GuiScreen
         }
         Mouse.getDWheel();
 
-        drawDefaultBackground();
+        renderBackground();
 
         if (drawSidebar()){
             overlayBackground(0, pageListRight, top, bottom, 0x202020);
         }
 
-        renderAchievementsPanel(mouseX, mouseY, partialTick);
+        renderAchievementsPanel(xm, ym, partialTick);
 
         overlayBackground(0, width, 0, top, 0x404040);
         overlayBackground(0, width, bottom, height, 0x404040);
@@ -296,7 +296,7 @@ public class GuiAchievements extends GuiScreen
         GL11.glShadeModel(GL11.GL_SMOOTH);
         GL11.glEnable(GL11.GL_TEXTURE_2D);
 
-        super.drawScreen(mouseX, mouseY, partialTick); // Draw Buttons
+        super.render(xm, ym, partialTick); // Draw Buttons
         GL11.glEnable(GL11.GL_DEPTH_TEST);
         GL11.glEnable(GL11.GL_LIGHTING);
         Lighting.disable();
@@ -314,8 +314,8 @@ public class GuiAchievements extends GuiScreen
             if (pagesListHeight < bottom - top) {
                 pagesListY = top + (bottom - top - pagesListHeight) / 2;
             }
-            if (mouseY >= top && mouseY <= bottom) {
-                hoveredPage = drawPagesListItems(pageListLeft + PADDING - 4, pagesListY, pageListRight - PADDING, mouseX, mouseY);
+            if (ym >= top && ym <= bottom) {
+                hoveredPage = drawPagesListItems(pageListLeft + PADDING - 4, pagesListY, pageListRight - PADDING, xm, ym);
             } else {
                 hoveredPage = drawPagesListItems(pageListLeft + PADDING - 4, pagesListY, pageListRight - PADDING, -1, -1);
             }
@@ -391,14 +391,14 @@ public class GuiAchievements extends GuiScreen
         }
 
         if (hoveredAchievement != null){
-            drawAchievementToolTip(hoveredAchievement, mouseX, mouseY);
+            drawAchievementToolTip(hoveredAchievement, xm, ym);
         }
 
         if (drawSidebar()) {
-            drawPagesListScrollBar(mouseX, mouseY);
+            drawPagesListScrollBar(xm, ym);
 
             if (hoveredPage != null){
-                String msg = fontRenderer.wrapFormattedStringToWidth(hoveredPage.getDescription(), TOOLTIP_BOX_WIDTH_MIN);
+                String msg = font.wrapFormattedStringToWidth(hoveredPage.getDescription(), TOOLTIP_BOX_WIDTH_MIN);
                 int completed = 0;
                 for (Achievement a : hoveredPage.getAchievements()){
                     if (statsCounter.isUnlocked(a)){
@@ -406,7 +406,7 @@ public class GuiAchievements extends GuiScreen
                     }
                 }
                 msg += "\n" + TextFormatting.LIGHT_GRAY + I18n.getInstance().translateKeyAndFormat("gui.achievements.label.completion",  Math.round(hoveredPage.getCompletionFraction(statsCounter) * 100) + "%");
-                tooltip.render(msg, mouseX, mouseY, TOOLTIP_OFF_X, TOOLTIP_OFF_Y);
+                tooltip.render(msg, xm, ym, TOOLTIP_OFF_X, TOOLTIP_OFF_Y);
             }
         }
 
@@ -434,7 +434,7 @@ public class GuiAchievements extends GuiScreen
     }
 
     protected void renderLabels() {
-        fontRenderer.drawCenteredString(I18n.getInstance().translateKey("gui.achievements.label.title")/* + " " + viewportZoom + " X:" + currentShiftX + ", Y:" + currentShiftY*/, width/2, 5 , 0xFFFFFF);
+        font.drawCenteredString(I18n.getInstance().translateKey("gui.achievements.label.title")/* + " " + viewportZoom + " X:" + currentShiftX + ", Y:" + currentShiftY*/, width/2, 5 , 0xFFFFFF);
     }
 
 
@@ -822,7 +822,7 @@ public class GuiAchievements extends GuiScreen
             GL11.glTranslated(achViewX + 3 * zoom, achViewY + 3 * zoom, 0);
             GL11.glScaled(zoom, zoom, 1);
             ItemModelDispatcher.getInstance().getDispatch(achievementItem)
-                .renderItemIntoGui(Tessellator.instance, mc.fontRenderer, mc.renderEngine, achievementItem.getDefaultStack(), 0, 0, 1.0f);
+                .renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, achievementItem.getDefaultStack(), 0, 0, 1.0f);
 
             GL11.glDisable(GL11.GL_LIGHTING);
             GL11.glPopMatrix();
@@ -842,25 +842,25 @@ public class GuiAchievements extends GuiScreen
         final int padding = tooltip.getPadding();
         int[] boxRender;
         if(statsCounter.canUnlock(achievement)) { // Can unlock/ is unlocked
-            int boxWidth = Math.max(fontRenderer.getStringWidth(name), TOOLTIP_BOX_WIDTH_MIN);
-            int boxHeight = fontRenderer.getHeightOfConstrainedString(desc, boxWidth);
+            int boxWidth = Math.max(font.getStringWidth(name), TOOLTIP_BOX_WIDTH_MIN);
+            int boxHeight = font.getHeightOfConstrainedString(desc, boxWidth);
             if(statsCounter.isUnlocked(achievement)) {
                 boxHeight += 12;
             }
             boxRender = tooltip.drawBackground(mouseX, mouseY, TOOLTIP_OFF_X, TOOLTIP_OFF_Y, boxWidth + 3, boxHeight + 3 + 12);
-            fontRenderer.drawStringIntoConstrainedBlock(desc, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth, 0xffa0a0a0);
+            font.drawStringIntoConstrainedBlock(desc, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth, 0xffa0a0a0);
             if(statsCounter.isUnlocked(achievement)) { // Add taken string to bottom
-                fontRenderer.drawStringWithShadow(I18n.getInstance().translateKey("gui.achievements.label.taken"), boxRender[0] + padding, boxRender[1] + boxHeight + 8 + padding, 0xff9090ff);
+                font.drawStringWithShadow(I18n.getInstance().translateKey("gui.achievements.label.taken"), boxRender[0] + padding, boxRender[1] + boxHeight + 8 + padding, 0xff9090ff);
             }
         } else { // Not unlocked so darken
-            int boxWidth = Math.max(fontRenderer.getStringWidth(name), TOOLTIP_BOX_WIDTH_MIN);
+            int boxWidth = Math.max(font.getStringWidth(name), TOOLTIP_BOX_WIDTH_MIN);
             String msg = I18n.getInstance().translateKeyAndFormat("gui.achievements.label.requires", achievement.parent.getStatName());
-            int boxHeight = fontRenderer.getHeightOfConstrainedString(msg, boxWidth);
+            int boxHeight = font.getHeightOfConstrainedString(msg, boxWidth);
             boxRender = tooltip.drawBackground(mouseX, mouseY, TOOLTIP_OFF_X, TOOLTIP_OFF_Y, boxWidth + 3, boxHeight + 3 + 12);
-            fontRenderer.drawStringIntoConstrainedBlock(msg, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth, 0xff705050);
+            font.drawStringIntoConstrainedBlock(msg, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth, 0xff705050);
         }
         int color = statsCounter.canUnlock(achievement) ? achievement.getType().colorName : achievement.getType().colorNameLocked;
-        fontRenderer.drawStringWithShadow(name, boxRender[0] + padding, boxRender[1] + padding, color);
+        font.drawStringWithShadow(name, boxRender[0] + padding, boxRender[1] + padding, color);
     }
     public boolean drawSidebar(){
         return AchievementPageRegistry.getInstance().getPages().size() > 1;
@@ -900,7 +900,7 @@ public class GuiAchievements extends GuiScreen
                 GL11.glColor4f(1f, 1f, 1f, 1f);
                 drawGuiIcon(x + 8, y2 + (PAGE_BUTTON_HEIGHT / 2) - 9 + 8, 11, 11, TextureRegistry.getTexture("minecraft:gui/achievement/star"));
             }
-            mc.fontRenderer.drawStringWithShadow(name, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
+            mc.font.drawStringWithShadow(name, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
             y2 += PAGE_BUTTON_HEIGHT;
         }
 
@@ -954,7 +954,7 @@ public class GuiAchievements extends GuiScreen
     private void overlayBackground(int minX, int maxX, int minY, int maxY, int color)
     {
         Tessellator tessellator = Tessellator.instance;
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         float scale = 32F;
         tessellator.startDrawingQuads();
diff --git a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
index d6798d336..656bf7e2c 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.gui.achievements.data;
 
-import net.minecraft.client.gui.achievements.GuiAchievements;
+import net.minecraft.client.gui.achievements.AchievementsScreen;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.achievement.Achievement;
@@ -29,9 +29,9 @@ public abstract class AchievementPage {
 
     public abstract @NotNull Achievement onOpenAchievement();
 
-    public abstract @Nullable IconCoordinate getBackgroundTile(GuiAchievements gui, int layer, Random random, int tileX, int tileY);
+    public abstract @Nullable IconCoordinate getBackgroundTile(AchievementsScreen screen, int layer, Random random, int tileX, int tileY);
 
-    public abstract void postProcessBackground(GuiAchievements gui, Random random, GuiAchievements.BGLayer layerCache, int orgX, int orgY);
+    public abstract void postProcessBackground(AchievementsScreen screen, Random random, AchievementsScreen.BGLayer layerCache, int orgX, int orgY);
 
     public abstract @NotNull ItemStack getIcon();
 
diff --git a/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java b/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java
index 46720681f..33cfda288 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java
@@ -1,9 +1,8 @@
 package net.minecraft.client.gui.achievements.pages;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.achievements.GuiAchievements;
+import net.minecraft.client.gui.achievements.AchievementsScreen;
 import net.minecraft.client.gui.achievements.data.AchievementPage;
-import net.minecraft.client.gui.achievements.data.AchievementPages;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.achievement.Achievement;
@@ -42,7 +41,7 @@ public class NetherPage extends AchievementPage {
     }
 
     @Override
-    public IconCoordinate getBackgroundTile(GuiAchievements guiAchievements, int layer, Random random, int tileX, int tileY) {
+    public IconCoordinate getBackgroundTile(AchievementsScreen screen, int layer, Random random, int tileX, int tileY) {
         random.setSeed(random.nextLong() + key.hashCode()); // makes seed different for each instance of this class :)
 
         final int bedrockLayer = 35;
@@ -61,7 +60,7 @@ public class NetherPage extends AchievementPage {
     }
 
     @Override
-    public void postProcessBackground(GuiAchievements gui, Random random, GuiAchievements.BGLayer layerCache, int orgX, int orgY) {
+    public void postProcessBackground(AchievementsScreen screen, Random random, AchievementsScreen.BGLayer layerCache, int orgX, int orgY) {
         if (layerCache.id == 0) {
             int lastY = 0;
             int cave = -1;
@@ -71,7 +70,7 @@ public class NetherPage extends AchievementPage {
                 }
                 if (cave > 0){
                     lastY = (25 + random.nextInt(4) - random.nextInt(4));
-                    carveCircle(gui, layerCache, _x - orgX, lastY - orgY, 2 + random.nextInt(3));
+                    carveCircle(screen, layerCache, _x - orgX, lastY - orgY, 2 + random.nextInt(3));
                 }
                 cave--;
             }
@@ -81,7 +80,7 @@ public class NetherPage extends AchievementPage {
                     cave = 5 + random.nextInt(5) - random.nextInt(5);
                 }
                 if (cave > 0){
-                    carveCircle(gui, layerCache, _x - orgX, (10 + random.nextInt(2) - random.nextInt(2)) - orgY, random.nextInt(3));
+                    carveCircle(screen, layerCache, _x - orgX, (10 + random.nextInt(2) - random.nextInt(2)) - orgY, random.nextInt(3));
                 }
                 cave--;
             }
@@ -124,7 +123,7 @@ public class NetherPage extends AchievementPage {
         return 0xff0000;
     }
 
-    protected void carveCircle(GuiAchievements gui, GuiAchievements.BGLayer layer, int centerX, int centerY, int radius){
+    protected void carveCircle(AchievementsScreen screen, AchievementsScreen.BGLayer layer, int centerX, int centerY, int radius){
         for (int i = centerX - radius; i <= centerX + radius ; i++) {
             for (int j = centerY - radius; j < centerY + radius; j++) {
                 double diffX = (i + 0.5) - centerX;
diff --git a/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java b/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java
index 63e34bf9a..3dd29cc46 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.achievements.pages;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.achievements.GuiAchievements;
+import net.minecraft.client.gui.achievements.AchievementsScreen;
 import net.minecraft.client.gui.achievements.data.AchievementPage;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -57,7 +57,7 @@ public class OverworldPage extends AchievementPage {
     protected static final Block[] BASALT_ORES = new Block[]    { Blocks.ORE_COAL_BASALT,   Blocks.ORE_IRON_BASALT,     Blocks.ORE_GOLD_BASALT,     Blocks.ORE_DIAMOND_BASALT,      Blocks.ORE_REDSTONE_BASALT,     Blocks.ORE_LAPIS_BASALT};
 
     @Override
-    public IconCoordinate getBackgroundTile(GuiAchievements guiAchievements, int layer, Random random, int tileX, int tileY) {
+    public IconCoordinate getBackgroundTile(AchievementsScreen screen, int layer, Random random, int tileX, int tileY) {
         random.setSeed(random.nextLong() + key.hashCode()); // makes seed different for each instance of this class :)
         // expect x range from  0  to 45
         // expect y range from -12 to 50
@@ -96,7 +96,7 @@ public class OverworldPage extends AchievementPage {
     }
 
     @Override
-    public void postProcessBackground(GuiAchievements gui, Random random, GuiAchievements.BGLayer layer, int orgX, int orgY) {
+    public void postProcessBackground(AchievementsScreen screen, Random random, AchievementsScreen.BGLayer layer, int orgX, int orgY) {
         random.setSeed(random.nextLong() + key.hashCode()); // makes seed different for each instance of this class :)
         if (layer.id == 0) {
 
@@ -128,7 +128,7 @@ public class OverworldPage extends AchievementPage {
                     } else {
                         layer.put(null, _x - orgX, rY - orgY);
                     }
-                    gui.getLayer(1).put(null, _x - orgX, rY - orgY);
+                    screen.getLayer(1).put(null, _x - orgX, rY - orgY);
                 }
             }
 
@@ -142,7 +142,7 @@ public class OverworldPage extends AchievementPage {
                 }
                 if (cave > 0){
                     lastY = (25 + random.nextInt(4) - random.nextInt(4));
-                    carveCircle(gui, layer, _x - orgX, lastY - orgY, 2 + random.nextInt(3));
+                    carveCircle(screen, layer, _x - orgX, lastY - orgY, 2 + random.nextInt(3));
                 }
                 if (cave == 0 && (-10 <= _x && _x <= 40)) {
                     brickPos = new int[]{_x, lastY};
@@ -155,7 +155,7 @@ public class OverworldPage extends AchievementPage {
                     cave = 5 + random.nextInt(5) - random.nextInt(5);
                 }
                 if (cave > 0){
-                    carveCircle(gui, layer, _x - orgX, (10 + random.nextInt(2) - random.nextInt(2)) - orgY, random.nextInt(3));
+                    carveCircle(screen, layer, _x - orgX, (10 + random.nextInt(2) - random.nextInt(2)) - orgY, random.nextInt(3));
                 }
                 cave--;
             }
@@ -164,7 +164,7 @@ public class OverworldPage extends AchievementPage {
                 brickPos = new int[]{5 + random.nextInt(20) + random.nextInt(20), 15 + random.nextInt(10)};
             }
 
-            placeStructure(gui, dungeonBrick, brickPos[0] - orgX,brickPos[1] - orgY, (struct, cache) -> {
+            placeStructure(screen, dungeonBrick, brickPos[0] - orgX,brickPos[1] - orgY, (struct, cache) -> {
                 if (cache == null) {
                     if (struct == chest || struct == spawner) {
                         return struct;
@@ -173,7 +173,7 @@ public class OverworldPage extends AchievementPage {
                 }
                 return struct;
             });
-            placeStructure(gui, dungeonCobble, -orgX + 5 + random.nextInt(20) + random.nextInt(20),-orgY + 5 + random.nextInt(5), (struct, cache) -> {
+            placeStructure(screen, dungeonCobble, -orgX + 5 + random.nextInt(20) + random.nextInt(20),-orgY + 5 + random.nextInt(5), (struct, cache) -> {
                 if (cache == null) {
                     if (struct == chest || struct == spawner) {
                         return struct;
@@ -184,7 +184,7 @@ public class OverworldPage extends AchievementPage {
             });
         } else if (layer.id == 1) {
             // Remove covered icons
-            IconCoordinate[] foreground = gui.getLayer(0).getData();
+            IconCoordinate[] foreground = screen.getLayer(0).getData();
             IconCoordinate[] background = layer.getData();
             for (int i = 0; i < background.length; i++) {
                 if (foreground[i] != null && foreground[i] != spawner){
@@ -194,7 +194,7 @@ public class OverworldPage extends AchievementPage {
         }
     }
 
-    protected void carveCircle(GuiAchievements gui, GuiAchievements.BGLayer layer, int centerX, int centerY, int radius){
+    protected void carveCircle(AchievementsScreen screen, AchievementsScreen.BGLayer layer, int centerX, int centerY, int radius){
         for (int i = centerX - radius; i <= centerX + radius ; i++) {
             for (int j = centerY - radius; j < centerY + radius; j++) {
                 double diffX = (i + 0.5) - centerX;
@@ -206,12 +206,12 @@ public class OverworldPage extends AchievementPage {
         }
     }
 
-    protected void placeStructure(GuiAchievements gui, PageStructure structure, int tileX, int tileY, @Nullable BiFunction<IconCoordinate, IconCoordinate, IconCoordinate> coordinateProcessor) {
+    protected void placeStructure(AchievementsScreen screen, PageStructure structure, int tileX, int tileY, @Nullable BiFunction<IconCoordinate, IconCoordinate, IconCoordinate> coordinateProcessor) {
         if (coordinateProcessor == null) {
             coordinateProcessor = (i, i2) -> i;
         }
         for (int layer = 0; layer < structure.layers; layer++) {
-            GuiAchievements.BGLayer cache = gui.getLayer(layer);
+            AchievementsScreen.BGLayer cache = screen.getLayer(layer);
             if (cache != null) {
                 for (int _x = 0; _x < structure.width; _x++) {
                     for (int _y = 0; _y < structure.height; _y++) {
